import numpy as np

def adjust_contrast(image, factor = 0.5):
    """
    

    Parameters
    ----------
    image : TYPE array
        Input image which we are going to adjust the contrast.
    factor : TYPE float, optional
        Factor used to adjust the contrast.The default is 0.5.
        
    Returns
    -------
    adjusted : TYPE array
        Output image whose the contrast has been adjusted.

    """
    adjusted = np.uint8(np.clip((factor * image) + 128 * (1 - factor), 0, 255))
    
    return adjusted