import cv2 as cv

def histogramme_rgb(nom_img):
    """
    

    Parameters
    ----------
    nom_img : TYPE str
        Input image's name to histogram.

    Returns
    -------
    histRGB : TYPE list of arrays
        It returns a list of three arrays of histogram points of dtype float32\
            for each color, such as Red, Green and Blue.


    """
    img = cv.imread(nom_img,cv.IMREAD_COLOR)
    color = ('b','g','r')
    histRGB = []
    for i,col in enumerate(color):
        histRGB.append(cv.calcHist([img],[i],None,[256],[0,256]))
    return histRGB