import numpy as np
import cv2
import sys
from PyQt5.QtGui import QPixmap,QImage,QCursor
from pyueye import ueye

from PyQt5.QtWidgets import (

    QApplication, QMainWindow, QGraphicsScene,QFileDialog

)

import time

from PyQt5 import QtCore, QtGui, QtWidgets

class Ui_MainWindow(object):

    def setupUi(self, MainWindow):
        """
        
           Define the widgets

           Used to setup the interface
           
           Generated with Qt Designer 

        """
        
        #Define the Main window and the layout :
        
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(722, 676)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        self.verticalLayout_2 = QtWidgets.QVBoxLayout(self.centralwidget)
        self.verticalLayout_2.setObjectName("verticalLayout_2")
        
        # Define the QGraphicsView to show the camera :
        
        self.camera_view = QtWidgets.QGraphicsView(self.centralwidget)
        self.camera_scene = QGraphicsScene()
        self.camera_view.setScene(self.camera_scene)
        self.camera_view.setObjectName("camera")
        self.verticalLayout_2.addWidget(self.camera_view)
        
        #Define the Menubar and Toolbar :
        
        MainWindow.setCentralWidget(self.centralwidget)
        
        #Set the Menubar
        
        self.menubar = QtWidgets.QMenuBar(MainWindow)
        self.menubar.setGeometry(QtCore.QRect(0, 0, 722, 26))
        self.menubar.setObjectName("menubar")
        
        #Set File in the menubar
        self.menuFichier = QtWidgets.QMenu(self.menubar)
        self.menuFichier.setObjectName("menuFichier")
        
        #Set Edit in the menubar
        self.menu_Editer = QtWidgets.QMenu(self.menubar)
        self.menu_Editer.setObjectName("menu_Editer")
        
        #Set "Acquisition" in the menubar
        self.menu_Acquisition = QtWidgets.QMenu(self.menubar)
        self.menu_Acquisition.setObjectName("menu_Acquisition")
        
        #Set "Affichage" in the menubar
        self.menuAffichage = QtWidgets.QMenu(self.menubar)
        self.menuAffichage.setObjectName("menuAffichage")
        MainWindow.setMenuBar(self.menubar)
        self.toolBar = QtWidgets.QToolBar(MainWindow)
        self.toolBar.setContextMenuPolicy(QtCore.Qt.PreventContextMenu)
        self.toolBar.setObjectName("toolBar")
        MainWindow.addToolBar(QtCore.Qt.TopToolBarArea, self.toolBar)
        self.statusbar = QtWidgets.QStatusBar(MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)
        
        #Define action to Save the image :
        self.action_Enregistrer_image = QtWidgets.QAction(MainWindow)
        self.action_Enregistrer_image.setCheckable(False)
        self.action_Enregistrer_image.setEnabled(True)
        icon = QtGui.QIcon()
        icon.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/Save.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.action_Enregistrer_image.setIcon(icon)
        self.action_Enregistrer_image.setMenuRole(QtWidgets.QAction.TextHeuristicRole)
        self.action_Enregistrer_image.setObjectName("action_Enregistrer_image")
        
        
        #Define action for the threshold  : 
        self.action_seuil = QtWidgets.QAction(MainWindow)
        self.action_seuil.setCheckable(False)
        self.action_seuil.setEnabled(True)
        self.action_seuil.setMenuRole(QtWidgets.QAction.TextHeuristicRole)
        self.action_seuil.setObjectName("action_Seuillage")
        
        #Define action to Detect rectangles in the image :
        self.action_detect_rectangles = QtWidgets.QAction(MainWindow)
        self.action_detect_rectangles.setCheckable(False)
        self.action_detect_rectangles.setEnabled(True)
        self.action_detect_rectangles.setMenuRole(QtWidgets.QAction.TextHeuristicRole)
        self.action_detect_rectangles.setObjectName("Détection Rectangles")
        
        #Define action to apply an Highpass_filter :
        self.action_apply_highpass_filter = QtWidgets.QAction(MainWindow)
        self.action_apply_highpass_filter.setCheckable(False)
        self.action_apply_highpass_filter.setEnabled(True)
        self.action_apply_highpass_filter.setMenuRole(QtWidgets.QAction.TextHeuristicRole)
        self.action_apply_highpass_filter.setObjectName("Action_Filtre_passe_haut")
        
        self.action_Temps_d_affichage = QtWidgets.QAction(MainWindow)
        icon1 = QtGui.QIcon()
        icon1.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/Parameters.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        
        #Define action for our display time (not used in the interface) :

        self.action_Temps_d_affichage.setIcon(icon1)
        self.action_Temps_d_affichage.setObjectName("action_Temps_d_affichage")
        
        
        #Define action to quit the interface :
        self.action_Quitter = QtWidgets.QAction(MainWindow)
        self.action_Quitter.setObjectName("action_Quitter")
        
        
        #Define action to save our data (not used in the interface) :

        self.actionEnregistrer_mesure = QtWidgets.QAction(MainWindow)
        icon2 = QtGui.QIcon()
        icon2.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/Enregistrer text.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionEnregistrer_mesure.setIcon(icon2)
        self.actionEnregistrer_mesure.setObjectName("actionEnregistrer_mesure")
        
        #Put an icon and a name tp the action to show a video :
        
        self.actionAcquisition_Vid_o = QtWidgets.QAction(MainWindow)
        icon3 = QtGui.QIcon()
        icon3.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/Video.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionAcquisition_Vid_o.setIcon(icon3)
        self.actionAcquisition_Vid_o.setObjectName("actionAcquisition_Vid_o")
        
        #Put an icon and a name tp the action to show a photo :
        
        self.actionAcquisition_Photo = QtWidgets.QAction(MainWindow)
        icon4 = QtGui.QIcon()
        icon4.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/Photo.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionAcquisition_Photo.setIcon(icon4)
        self.actionAcquisition_Photo.setObjectName("actionAcquisition_Photo")
        
        #Define the action to zoom and put an icon to it.
        self.actionZoomer = QtWidgets.QAction(MainWindow)
        icon5 = QtGui.QIcon()
        icon5.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/zoom in.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionZoomer.setIcon(icon5)
        self.actionZoomer.setObjectName("actionZoomer")
        
        #Define the action to dezoom and put an icon to it.
        self.actionD_zoomer = QtWidgets.QAction(MainWindow)
        icon6 = QtGui.QIcon()
        icon6.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/zoom out.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionD_zoomer.setIcon(icon6)
        self.actionD_zoomer.setObjectName("actionD_zoomer")
        
        
        #Define an action to mask the image (not used in the interface)
        self.actionMasquage = QtWidgets.QAction(MainWindow)
        icon7 = QtGui.QIcon()
        icon7.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/Masquage.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionMasquage.setIcon(icon7)
        self.actionMasquage.setObjectName("actionMasquage")
        
        #Define an action to show our differents measures (exposure time...)

        self.actionMesure = QtWidgets.QAction(MainWindow)
        icon8 = QtGui.QIcon()
        icon8.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/Mesure règle.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionMesure.setIcon(icon8)
        self.actionMesure.setObjectName("actionMesure")
        
    
        #Define an action to show an histogram of the image (not used in the interface)

        self.actionHistogramme = QtWidgets.QAction(MainWindow)
        icon9 = QtGui.QIcon()
        icon9.addPixmap(QtGui.QPixmap("D:/Projets/2023_Interface Camera Gr4/ui/ressources/Histogramme.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.actionHistogramme.setIcon(icon9)
        self.actionHistogramme.setObjectName("actionHistogramme")
        
        
        #Define an action to detect the colors in the screen (not used in the interface)

        self.action_D_tection_de_couleurs = QtWidgets.QAction(MainWindow)
        self.action_D_tection_de_couleurs.setObjectName("action_D_tection_de_couleurs")
        
        #Add all the actions in the various menu (file, edit...)
        self.menuFichier.addAction(self.action_Enregistrer_image)
        self.menuFichier.addAction(self.actionEnregistrer_mesure)
        self.menu_Editer.addAction(self.action_seuil)
        self.menu_Editer.addAction(self.action_detect_rectangles)
        self.menu_Editer.addAction(self.action_apply_highpass_filter)
        self.menuFichier.addSeparator()
        self.menuFichier.addAction(self.action_Quitter)
        self.menu_Editer.addAction(self.actionZoomer)
        self.menu_Editer.addAction(self.actionD_zoomer)
        self.menu_Acquisition.addAction(self.action_Temps_d_affichage)
        self.menu_Acquisition.addSeparator()
        self.menu_Acquisition.addAction(self.actionAcquisition_Vid_o)
        self.menu_Acquisition.addAction(self.actionAcquisition_Photo)
        self.menu_Acquisition.addSeparator()
        self.menu_Acquisition.addAction(self.actionMasquage)
        self.menuAffichage.addAction(self.actionHistogramme)
        self.menuAffichage.addAction(self.actionMesure)
        self.menuAffichage.addSeparator()
        self.menuAffichage.addAction(self.action_D_tection_de_couleurs)
        self.menubar.addAction(self.menuFichier.menuAction())
        self.menubar.addAction(self.menu_Editer.menuAction())
        self.menubar.addAction(self.menu_Acquisition.menuAction())
        self.menubar.addAction(self.menuAffichage.menuAction())
        self.toolBar.addAction(self.action_Enregistrer_image)
        self.toolBar.addAction(self.actionEnregistrer_mesure)
        self.toolBar.addSeparator()
        self.toolBar.addAction(self.actionAcquisition_Photo)
        self.toolBar.addAction(self.actionAcquisition_Vid_o)
        self.toolBar.addSeparator()
        self.toolBar.addAction(self.actionZoomer)
        self.toolBar.addAction(self.actionD_zoomer)
        self.toolBar.addSeparator()
        self.toolBar.addAction(self.actionMasquage)
        self.toolBar.addSeparator()
        self.toolBar.addAction(self.actionMesure)
        self.toolBar.addSeparator()
        self.toolBar.addAction(self.actionHistogramme)
        self.toolBar.addSeparator()
        self.toolBar.addAction(self.action_Temps_d_affichage)

        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)

    #Mettre le texte sur les actions de la toolbar (et image) : 

    def retranslateUi(self, MainWindow):
        
        """
        
        Used to set the text associated with the various actions
        
        Generated with Qt Designer 
        
        """
        
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "MainWindow"))
        self.menuFichier.setTitle(_translate("MainWindow", "&Fichier"))
        self.menu_Editer.setTitle(_translate("MainWindow", "&Edition"))
        self.menu_Acquisition.setTitle(_translate("MainWindow", "&Acquisition"))
        self.menuAffichage.setTitle(_translate("MainWindow", "&Mesures"))
        self.toolBar.setWindowTitle(_translate("MainWindow", "toolBar"))
        self.action_Enregistrer_image.setText(_translate("MainWindow", "&Enregistrer image"))
        self.action_Enregistrer_image.setToolTip(_translate("MainWindow", "Enregistrer l\'image"))
        self.action_seuil.setText(_translate("MainWindow", "&Seuillage"))
        self.action_seuil.setToolTip(_translate("MainWindow", "Seuillage"))
        self.action_detect_rectangles.setText(_translate("MainWindow", "&Detection Rectangles"))
        self.action_detect_rectangles.setToolTip(_translate("MainWindow", "Seuillage"))
        self.action_Temps_d_affichage.setText(_translate("MainWindow", "&Paramètres"))
        self.action_Quitter.setText(_translate("MainWindow", "&Quitter"))
        self.actionEnregistrer_mesure.setText(_translate("MainWindow", "&Enregistrer mesure"))
        self.actionAcquisition_Vid_o.setText(_translate("MainWindow", "&Acquisition Vidéo"))
        self.actionAcquisition_Photo.setText(_translate("MainWindow", "&Acquisition Photo"))
        self.actionZoomer.setText(_translate("MainWindow", "&Zoomer"))
        self.actionD_zoomer.setText(_translate("MainWindow", "&Dézoomer"))
        self.actionMasquage.setText(_translate("MainWindow", "&Masquage"))
        self.actionMesure.setText(_translate("MainWindow", "&Mesurer"))
        self.actionHistogramme.setText(_translate("MainWindow", "Histogramme"))
        self.action_D_tection_de_couleurs.setText(_translate("MainWindow", "&Détection de couleurs "))

class Window(QMainWindow, Ui_MainWindow):
    
    def __init__(self, parent=None):

        super().__init__(parent)
        
        # Setup the window
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        
        #Connect the action to acquire the video to the start of the video :
        
        self.ui.actionAcquisition_Vid_o.triggered.connect(self.start_video)
        
        self.ui.actionAcquisition_Photo.triggered.connect(self.acq_photo_triggered)

        #Connect the action "quitter" to close the window
        
        self.ui.action_Quitter.triggered.connect(self.close_window)
        
        #Connect the action to save the image 
        
        self.ui.action_Enregistrer_image.triggered.connect(self.save_image)
        
        # Create a timer to update the video
        self.ui.timer = QtCore.QTimer(self)
        self.ui.timer.timeout.connect(self.update_video)

        # Create the capture
        self.ui.video_capture = cv2.VideoCapture(0)
        
        # Boolean verify the initialisation of the camera (True means that the initialisation has been done)
        self.ui.init_bool = False
        
        # Boolean to zoom and dezoom 
        
        self.zoombool = False
        self.dezoombool = False       
        
        #Connect the action of zooming and dezooming 
        
        self.ui.actionD_zoomer.triggered.connect(self.dezoom_triggered)
        
        self.ui.actionZoomer.triggered.connect(self.zoom_triggered)
        
        #Connect the action for the threshold 

        
        self.ui.action_seuil.triggered.connect(self.seuillage_triggered)
        
        #Boolean used to apply the threshold if it's True
        
        self.seuil_triggered_bool = False
        
        #Boolean used to detect the rectangles if it's True
        
        self.detect_rectangle_bool = False
        
        #Boolean used to apply the filter if it's True

        
        self.detect_apply_highpass_filter_bool = False
        
        
        #Connect the action for the histogram (not functional)
        
        self.ui.actionHistogramme.triggered.connect(self.histogram_rgb)
        
        #Connect the action to detect the rectangles (not functional)

        self.ui.action_detect_rectangles.triggered.connect(self.detect_rectangles)
        
        #Connect the action to apply the Filter
        
        self.ui.action_apply_highpass_filter.triggered.connect(self.apply_highpass_filter)
    
    
    def seuillage_triggered(self):
        
        """
        
        Done every time we click on the action for the threshold
        
        
        """
        
        self.seuil_triggered_bool = not(self.seuil_triggered_bool)
    
    def detect_rectangle_triggered(self):
        
        """
        
        Done every time we click on the action to detect the rectangle
                
        """
        
        self.detect_rectangle_bool = not(self.detect_rectangle_bool)
        
    def apply_highpass_filter_triggered(self):
        
        """
        
        Done every time we click on the action to detect the rectangle
        
        
        """
        
        self.detect_apply_highpass_filter_bool = not(self.detect_apply_highpass_filter_bool)

    def zoom_triggered(self):
        #Change the boolean every time we click on the action
        self.zoombool = not(self.zoombool)
        
        self.dezoombool = False

        if self.zoombool:
            # Put an icon for the zoom instead of the cursor (the filepath needs to be changed)
            self.ui.camera_view.setCursor(QCursor(QPixmap("C:/Users/Corentin/Downloads/zoom.png")))
        else:
            # Unset the icon
            self.ui.camera_view.unsetCursor()
        
    def dezoom_triggered(self):
        self.zoombool = False
        
        #Change the boolean every time we click on the action
        self.dezoombool = not(self.dezoombool)
        if self.dezoombool:
            # Put an icon for the zoom instead of the cursor (the filepath needs to be changed)
            self.ui.camera_view.setCursor(QCursor(QPixmap("C:/Users/Corentin/Downloads/zoom out.png")))
        else:
            # Unset the icon
            self.ui.camera_view.unsetCursor()
    
    def mousePressEvent(self, event):
        
        """
        
        Event every time we click on the image
        
        """
        
        #Zoom
        if event.button() == QtCore.Qt.LeftButton and self.zoombool:
            self.zoom(event.pos(), 1.5)
            #Get the x and y coordinates of the point we clicked on
            self.x = event.pos().x()
            self.y = event.pos().y()
            
        #Dezoom
        if event.button() == QtCore.Qt.LeftButton and self.dezoombool:
            #Get the x and y coordinates of the point we clicked on
            self.zoom(event.pos(), 0.75)
            self.x = event.pos().x()
            self.y = event.pos().y()

    def zoom(self, point, factor):
        
        """
        
        Another methods to zoom, it reduces directly the frame (for the video
        because the other way to zoom doesn't work for a video)
        
        Is'nt working for now
        
        """
        
        self.ui.camera_view.centerOn(self.ui.camera_view.mapToScene(point))
        self.ui.camera_view.scale(factor, factor)
        new_width = int(self.ui.width * factor)
        new_height = int(self.ui.height * factor)

        # Calculate the new coordinates of the center point after zooming
        new_center_x = self.x
        new_center_y = self.y

        # Calculate the x and y coordinates of the top-left corner of the zoomed image
        x = new_center_x - int(new_width / 2)
        y = new_center_y - int(new_height / 2)

        # Check if the zoomed image is within the bounds of the original image
        if x < 0 or y < 0 or x + new_width > self.ui.width or y + new_height > self.ui.height:
            raise ValueError("Zoomed image is out of bounds")

        # Crop the image to the zoomed ROI and resize to the original image size
        self.ui.frame = cv2.resize(self.ui.frame[y:y+new_height, x:x+new_width], (self.ui.width, self.ui.height))
        self.ui.width = new_width
        self.ui.height = new_height

                    
    def quit_video(self):
        """
        
        Used to end the video acquisitin and clear the screen
        
        """
        self.ui.camera_scene.clear()
        self.ui.timer.stop()

    def init_camera(self):
        
        """
        
        Used to initialize the camera and its parameters
        
        """
        
        self.ui.hCam = ueye.HIDS(0)             #0: first available camera;  1-254: The camera with the specified camera ID
        self.ui.sInfo = ueye.SENSORINFO()
        self.ui.cInfo = ueye.CAMINFO()
        self.ui.pcImageMemory = ueye.c_mem_p()
        self.ui.MemID = ueye.int()
        self.ui.rectAOI = ueye.IS_RECT()
        self.ui.pitch = ueye.INT()
        self.ui.nBitsPerPixel = ueye.INT(24)    #24: bits per pixel for color mode; take 8 bits per pixel for monochrome
        self.ui.channels = 3                    #3: channels for color mode(RGB); take 1 channel for monochrome
        self.ui.m_nColorMode = ueye.INT()		# Y8/RGB16/RGB24/REG32
        self.ui.bytes_per_pixel = int(self.ui.nBitsPerPixel / 8)
        #---------------------------------------------------------------------------------------------------------------------------------------
        print("START")
        print()
        
        
        # Starts the driver and establishes the connection to the camera
        self.ui.nRet = ueye.is_InitCamera(self.ui.hCam, None)
        if self.ui.nRet != ueye.IS_SUCCESS:
            print("is_InitCamera ERROR")
        
        # Reads out the data hard-coded in the non-volatile camera memory and writes it to the data structure that cInfo points to
        self.ui.nRet = ueye.is_GetCameraInfo(self.ui.hCam, self.ui.cInfo)
        if self.ui.nRet != ueye.IS_SUCCESS:
            print("is_GetCameraInfo ERROR")
        
        # You can query additional information about the sensor type used in the camera
        self.ui.nRet = ueye.is_GetSensorInfo(self.ui.hCam, self.ui.sInfo)
        if self.ui.nRet != ueye.IS_SUCCESS:
            print("is_GetSensorInfo ERROR")
        
        self.ui.nRet = ueye.is_ResetToDefault(self.ui.hCam)
        if self.ui.nRet != ueye.IS_SUCCESS:
            print("is_ResetToDefault ERROR")
        
        # Set display mode to DIB
        self.ui.nRet = ueye.is_SetDisplayMode(self.ui.hCam, ueye.IS_SET_DM_DIB)
        
        # Set the right color mode
        if int.from_bytes(self.ui.sInfo.nColorMode.value, byteorder='big') == ueye.IS_COLORMODE_BAYER:
            # setup the color depth to the current windows setting
            ueye.is_GetColorDepth(self.ui.hCam, self.ui.nBitsPerPixel, self.ui.m_nColorMode)
            self.ui.bytes_per_pixel = int(self.ui.nBitsPerPixel / 8)
            print("IS_COLORMODE_BAYER: ", )
            print("\tm_nColorMode: \t\t", self.ui.m_nColorMode)
            print("\tnBitsPerPixel: \t\t", self.ui.nBitsPerPixel)
            print("\tbytes_per_pixel: \t\t", self.ui.bytes_per_pixel)
            print()
        
        elif int.from_bytes(self.ui.sInfo.nColorMode.value, byteorder='big') == ueye.IS_COLORMODE_CBYCRY:
            # for color camera models use RGB32 mode
            self.ui.m_nColorMode = ueye.IS_CM_BGRA8_PACKED
            self.ui.nBitsPerPixel = ueye.INT(32)
            self.ui.bytes_per_pixel = int(self.ui.nBitsPerPixel / 8)
            print("IS_COLORMODE_CBYCRY: ", )
            print("\tm_nColorMode: \t\t", self.ui.m_nColorMode)
            print("\tnBitsPerPixel: \t\t", self.ui.nBitsPerPixel)
            print("\tbytes_per_pixel: \t\t", self.ui.bytes_per_pixel)
            print()
        
        elif int.from_bytes(self.ui.sInfo.self.ui.nColorMode.value, byteorder='big') == ueye.IS_COLORMODE_MONOCHROME:
            # for color camera models use RGB32 mode
            self.ui.m_nColorMode = ueye.IS_CM_MONO8
            self.ui.nBitsPerPixel = ueye.INT(8)
            self.ui.bytes_per_pixel = int(self.ui.nBitsPerPixel / 8)
            print("IS_COLORMODE_MONOCHROME: ", )
            print("\tm_nColorMode: \t\t", self.ui.m_nColorMode)
            print("\tnBitsPerPixel: \t\t", self.ui.nBitsPerPixel)
            print("\tbytes_per_pixel: \t\t", self.ui.bytes_per_pixel)
            print()
        
        else:
            # for monochrome camera models use Y8 mode
            self.ui.m_nColorMode = ueye.IS_CM_MONO8
            self.ui.nBitsPerPixel = ueye.INT(8)
            self.ui.bytes_per_pixel = int(self.ui.nBitsPerPixel / 8)
            print("else")
        
        # Can be used to set the size and position of an "area of interest"(AOI) within an image
        self.ui.nRet = ueye.is_AOI(self.ui.hCam, ueye.IS_AOI_IMAGE_GET_AOI, self.ui.rectAOI, ueye.sizeof(self.ui.rectAOI))
        if self.ui.nRet != ueye.IS_SUCCESS:
            print("is_AOI ERROR")
        
        self.ui.width = self.ui.rectAOI.s32Width
        self.ui.height = self.ui.rectAOI.s32Height
        
        # Prints out some information about the camera and the sensor
        print("Camera model:\t\t", self.ui.sInfo.strSensorName.decode('utf-8'))
        print("Camera serial no.:\t", self.ui.cInfo.SerNo.decode('utf-8'))
        print("Maximum image width:\t", self.ui.width)
        print("Maximum image height:\t", self.ui.height)
        print()

        
        # Allocates an image memory for an image having its dimensions defined by width and height and its color depth defined by nBitsPerPixel
        self.ui.nRet = ueye.is_AllocImageMem(self.ui.hCam, self.ui.width, self.ui.height, self.ui.nBitsPerPixel, self.ui.pcImageMemory, self.ui.MemID)
        if self.ui.nRet != ueye.IS_SUCCESS:
            print("is_AllocImageMem ERROR")
        else:
            # Makes the specified image memory the active memory
            self.ui.nRet = ueye.is_SetImageMem(self.ui.hCam, self.ui.pcImageMemory, self.ui.MemID)
            if self.ui.nRet != ueye.IS_SUCCESS:
                print("is_SetImageMem ERROR")
            else:
                # Set the desired color mode
                self.ui.nRet = ueye.is_SetColorMode(self.ui.hCam, self.ui.m_nColorMode)
        

        
        # Activates the camera's live video mode (free run mode)
        self.ui.nRet = ueye.is_CaptureVideo(self.ui.hCam, ueye.IS_DONT_WAIT)
        if self.ui.nRet != ueye.IS_SUCCESS:
            print("is_CaptureVideo ERROR")
        
        # Enables the queue mode for existing image memory sequences
        self.ui.nRet = ueye.is_InquireImageMem(self.ui.hCam, self.ui.pcImageMemory, self.ui.MemID, self.ui.width, self.ui.height, self.ui.nBitsPerPixel, self.ui.pitch)
        if self.ui.nRet != ueye.IS_SUCCESS:
            print("is_InquireImageMem ERROR")
        else:
            print("Press q to leave the programm")
        
        #The acquisition has now been done
        
        self.ui.init_bool = True
    
    def start_video(self):
        
        """
        
        Used to launch the timer : with this timer we will update the screen
        every 30 ms
        
        """
        
        # If the initialisation of the camera has'nt been done, we do it :
        if not(self.ui.init_bool):
            self.init_camera()
            
        self.ui.video_capture.open(0)
        
        # Define the timer with 30 ms
        self.ui.timer.start(30)
    
    def update_video(self):
        
        """
        
        Used to update the image shown at the end of the timer
        
        """
        
        ueye.is_FreezeVideo(self.ui.hCam, ueye.IS_WAIT)
        
        # Extract the data of our image memory        
        array = ueye.get_data(self.ui.pcImageMemory, self.ui.width, self.ui.height, self.ui.nBitsPerPixel, self.ui.pitch, copy=False)        
        
        # Reshape the data in an numpy array
        self.ui.frame = np.reshape(array,(self.ui.height.value, self.ui.width.value, self.ui.bytes_per_pixel))
     
        #Apply the different filter to the image :
        if self.seuil_triggered_bool:
            self.seuillage_RGB()
            
        if self.detect_rectangle_bool:
            self.detect_rectangles()
            
        if self.detect_apply_highpass_filter_bool:
            self.apply_highpass_filter()

        # Show the image
        image = QImage(self.ui.frame, self.ui.frame.shape[1], self.ui.frame.shape[0], QImage.Format_RGB32)
        pixmap = QPixmap.fromImage(image)
        self.ui.camera_scene.clear()
        self.ui.camera_view.fitInView(self.ui.camera_scene.sceneRect(), QtCore.Qt.KeepAspectRatio)
        self.ui.camera_scene.addPixmap(pixmap)
    
    def acq_photo_triggered(self):
        
        """
        
        Used to show an image of the camera in the Scene
        
        """
        
        #Initialize the camera if it hasn't been done
        if not(self.ui.init_bool):
            self.init_camera()
            
        time.sleep(1)
        
        #Stop the video
        self.quit_video()
        
        ueye.is_FreezeVideo(self.ui.hCam, ueye.IS_WAIT)
        
        # Extract the data of our image memory        

        array = ueye.get_data(self.ui.pcImageMemory, self.ui.width, self.ui.height, self.ui.nBitsPerPixel, self.ui.pitch, copy=False)
                
        # Reshape the data in an numpy array
        self.ui.frame = np.reshape(array,(self.ui.height.value, self.ui.width.value, self.ui.bytes_per_pixel))
        
        #Apply the different filter to the image :

        if self.seuil_triggered_bool:
            self.seuillage_RGB()
            
        if self.detect_rectangle_bool:
            self.detect_rectangles()
            
        if self.detect_apply_highpass_filter_bool:
            self.apply_highpass_filter()

        # Show the image
        image = QImage(self.ui.frame, self.ui.frame.shape[1], self.ui.frame.shape[0], QImage.Format_RGB32)
        pixmap = QPixmap.fromImage(image)
        self.ui.camera_scene.clear()
        self.ui.camera_view.fitInView(self.ui.camera_scene.sceneRect(), QtCore.Qt.KeepAspectRatio)
        self.ui.camera_scene.addPixmap(pixmap)

    def seuillage_RGB(self, value = 75):
        """
        A function used to "seuiller" a RGB image.
    
        Parameters
        ----------
        img : TYPE array
            Input image to threshold.
    
        Returns
        -------
        imgbin : TYPE array
            Output thresholded image.
    
        """
        b, g, r, a = cv2.split(self.ui.frame)
        thresh,img_r=cv2.threshold(r,0,value,cv2.THRESH_OTSU)
        thresh,img_g=cv2.threshold(g,0,value,cv2.THRESH_OTSU)
        thresh,img_b=cv2.threshold(b,0,value,cv2.THRESH_OTSU)
        self.ui.frame = cv2.merge([img_b, img_g, img_r,a])
        
    def histogram_rgb(self):
        """
        Function used to plot a histogram of a RGB image.

        Parameters
        ----------
        nom_img : TYPE str
            Input image's name to histogram.

        Returns
        -------
        hist_rgb : TYPE list of arrays
            It returns a list of three arrays of histogram points of dtype float32\
                for each color, such as Red, Green and Blue.


        """
        color = ('b','g','r','-')
        hist_rgb = []
        b, g, r, a = cv2.split(self.ui.frame)
        img = cv2.merge([b, g, r])
        for colors in enumerate(color):
            hist_rgb.append(cv2.calcHist([img],[colors[0]],None,[256],[0,256]))        
        
        # Display image in a window
        cv2.imshow("Image", hist_rgb)

        # Wait for a key press and then close the window
        cv2.waitKey(0)
        cv2.destroyAllWindows()
           
    def detect_rectangles(self):
        """
        Function used to detect rectangles in an image.

        Parameters
        ----------
        image : TYPE array
            Input image where we are going to detect rectangles from.

        Returns
        -------
        output : TYPE array
            Output image in grey scale where detected rectangles are drawn.

        """
        # Convert the image to grayscale
        gray = cv2.cvtColor(self.ui.frame, cv2.COLOR_BGR2GRAY)
        print(gray)

        # Apply a Gaussian blur to reduce noise
        blurred = cv2.GaussianBlur(gray, (5, 5), 0)
        print(blurred)
        # Apply Canny edge detection to highlight edges
        edges = cv2.Canny(blurred, 50, 150)
        print(edges)
        # Find contours in the edge image
        contours, hierarchy = cv2.findContours(edges, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)

        # Loop over the contours and find rectangles
        rectangles = []
        for contour in contours:
            perimeter = cv2.arcLength(contour, True)
            approx = cv2.approxPolyDP(contour, 0.02 * perimeter, True)
            if len(approx) == 4:
                rectangles.append(approx)
        print(rectangles)
        # Draw the rectangles on the original image
        output = self.ui.frame.copy()
        cv2.drawContours(output, rectangles, -1, (255, 0, 0), 2)
        self.ui.frame = output

    def detect_circles(self):
        """
        Function used to detect circles in an image.

        Parameters
        ----------
        image : TYPE array
            Input image where we are going to detect circles from.

        Returns
        -------
        output : TYPE array
            Output image in grey scale where detected circles are drawn.

        """
        # Convert the image to grayscale
        gray = cv2.cvtColor(self.ui.frame, cv2.COLOR_BGR2GRAY)

        # Apply a Gaussian blur to reduce noise
        blurred = cv2.GaussianBlur(gray, (5, 5), 0)

        # Apply Hough Circle Transform to detect circles
        circles = cv2.HoughCircles(blurred, cv2.HOUGH_GRADIENT, 1, 20, param1=50, param2=30, minRadius=0, maxRadius=0)

        # Draw the detected circles on the original image
        output = self.ui.frame.copy()
        circles = np.uint16(np.around(circles))
        for i in circles[0,:]:
            # draw the outer circle
            cv2.circle(output,(i[0],i[1]),i[2],(0,255,0),2)
            # draw the center of the circle
            cv2.circle(output,(i[0],i[1]),2,(0,0,255),3)

        self.ui.frame = output


    def detect_polygons(self):
        """
        Fonction used to detect polygons in an image.

        Parameters
        ----------
        image : TYPE array
            Input image where we are going to detect polygons from.

        Returns
        -------
        output : TYPE array
            Output image in grey scale where detected polygons are drawn.

        """
        # Convert the image to grayscale
        gray = cv2.cvtColor(self.ui.frame, cv2.COLOR_BGR2GRAY)

        # Apply a Gaussian blur to reduce noise
        blurred = cv2.GaussianBlur(gray, (5, 5), 0)

        # Threshold the image to create a binary image
        _, thresh = cv2.threshold(blurred, 60, 255, cv2.THRESH_BINARY)

        # Find contours in the binary image
        contours, _ = cv2.findContours(thresh, cv2.RETR_TREE, cv2.CHAIN_APPROX_SIMPLE)

        # Draw the detected polygons on the original image
        output = self.ui.frame.copy()
        for contour in contours:
            # Approximate the polygonal curves from the contours
            approx = cv2.approxPolyDP(contour, 0.01*cv2.arcLength(contour, True), True)

            # Draw the detected polygons with green color and thickness 2
            cv2.drawContours(output, [approx], 0, (0, 0, 255), 2)

        self.ui.frame = output    
        
    def apply_highpass_filter(self):
        """
        Function used to apply a highpass filter.

        Parameters
        ----------
        image : array
            Input image to sharpen.
        kernel_size : TYPE int, optional
            Gaussian Kernel Size. The default is 3.

        Returns
        -------
        sharpened : TYPE array
            Sharpened output image.

        """
    
        blurred = cv2.GaussianBlur(self.ui.frame, (3, 3), 0)
        laplacian = cv2.Laplacian(blurred, cv2.CV_64F)
        sharpened = np.uint8(np.clip(self.ui.frame - laplacian, 0, 255))
        self.ui.frame = sharpened


    def save_image(self):
        
        """
        
        Used to save the image
        
        """
        
        
        #Initialize the camera if it hasn't been done
        if not(self.ui.init_bool):
            self.init_camera()

        time.sleep(1)
        
        ueye.is_FreezeVideo(self.ui.hCam, ueye.IS_WAIT)
        
        
        # Extract the data of our image memory        

        array = ueye.get_data(self.ui.pcImageMemory, self.ui.width, self.ui.height, self.ui.nBitsPerPixel, self.ui.pitch, copy=False)
                
        # Reshape it in an numpy array
        self.ui.frame = np.reshape(array,(self.ui.height.value, self.ui.width.value, self.ui.bytes_per_pixel))
    
        #To open the dialog to save our image :
        file_name, _ = QFileDialog.getSaveFileName(
            self, "Enregistrer l'image", "", "Images (*.png *.xpm *.jpg)")
        
        #Save the image
        if file_name:
            cv2.imwrite(file_name, self.ui.frame)
        
    def close_window(self):
        
        """
        
        Done when we click on "quitter" (quit)
        
        Used to close the interface
        
        """
        
        #Stop the acquisition of the video
        self.quit_video()
        
        # Releases an image memory that was allocated using is_AllocImageMem() and removes it from the driver management
        ueye.is_FreeImageMem(self.ui.hCam, self.ui.pcImageMemory, self.ui.MemID)
        
        # Disables the hCam camera handle and releases the data structures and memory areas taken up by the uEye camera
        ueye.is_ExitCamera(self.ui.hCam)
        
        # Close the window
        self.close()
    
    
        return blurred

if __name__ == "__main__":

    app = QApplication(sys.argv)

    win = Window()

    win.show()

    sys.exit(app.exec())
